/*
 * ToRegExp.h
 *
 *  Created on: 9. 2. 2014
 *      Author: Jan Travnicek
 */

#ifndef _AUTOMATON_TO_REGEXP_H__
#define _AUTOMATON_TO_REGEXP_H__

#include <core/multipleDispatch.hpp>

#include <automaton/FSM/DFA.h>
#include <automaton/FSM/NFA.h>
#include <automaton/FSM/EpsilonNFA.h>
#include <regexp/unbounded/UnboundedRegExp.h>

#include <automaton/Automaton.h>
#include <regexp/RegExp.h>

namespace automaton {

namespace convert {

class ToRegExp : public std::SingleDispatch<ToRegExp, regexp::RegExp, automaton::AutomatonBase> {
public:
	/**
	 * Performs conversion.
	 * @return left regular grammar equivalent to source automaton.
	 */
	static regexp::RegExp convert(const automaton::Automaton& automaton);

	static regexp::RegExp convert(const EpsilonNFA& automaton);
	static regexp::RegExp convert(const MultiInitialStateNFA& automaton);
	static regexp::RegExp convert(const NFA& automaton);
	static regexp::RegExp convert(const DFA& automaton);
	static regexp::RegExp convert(const ExtendedNFA& automaton);
	static regexp::RegExp convert(const CompactNFA& automaton);
};

} /* namespace convert */

} /* namespace automaton */

#endif /* _AUTOMATON_TO_REGEXP_H__ */
