/*
 * UsefullStates.h
 *
 *  Created on: 23. 3. 2014
 *	  Author: Tomas Pecka
 */

#ifndef USEFULL_STATES_H_
#define USEFULL_STATES_H_

#include <core/multipleDispatch.hpp>
#include <algorithm>
#include <deque>
#include <set>

#include <automaton/common/State.h>
#include <automaton/Automaton.h>

namespace automaton {

namespace properties {

class UsefullStates : public std::SingleDispatch<UsefullStates, std::set<automaton::State>, automaton::AutomatonBase> {
public:
	static std::set<automaton::State> usefullStates( const automaton::Automaton & automaton );

	/**
	 * Removes dead states from FSM. Melichar 2.32
	 */
	template<class T>
	static std::set<automaton::State> usefullStates( const T & fsm );
};

} /* namespace properties */

} /* namespace automaton */

#endif /* USEFULL_STATES_H_ */
