/*
 * MinimizeBrzozowski.cpp
 *
 *  Created on: 18. 11. 2014
 *	  Author: Tomas Pecka
 */
 
#ifndef MINIMIZE_BRZOZOWSKI_H_
#define MINIMIZE_BRZOZOWSKI_H_

#include <core/multipleDispatch.hpp>
#include <automaton/Automaton.h>
#include <automaton/FSM/DFA.h>

namespace automaton {

namespace simplify {

class MinimizeBrzozowski : public std::SingleDispatch<MinimizeBrzozowski, automaton::Automaton, automaton::AutomatonBase> {
public:
	/**
	 * @param dfa automaton to minimize
	 */
	static automaton::Automaton minimize(const automaton::Automaton& dfa);

	static automaton::DFA minimize(const automaton::DFA& dfa);
	static automaton::DFA minimize(const automaton::NFA& nfa);
};

} /* namespace simplify */

} /* namespace automaton */

#endif /* MINIMIZE_BRZOZOWSKI_H_ */
