/*
 * RHPDAToPDA.h
 *
 *  Created on: 23. 3. 2014
 *	  Author: Jan Travnicek
 */

#ifndef RHPDA_TO_PDA_H_
#define RHPDA_TO_PDA_H_

#include <core/multipleDispatch.hpp>
#include <algorithm>
#include <deque>
#include <set>

#include "automaton/Automaton.h"
#include <automaton/common/State.h>

namespace automaton {

class RHPDAToPDA : public std::SingleDispatch<RHPDAToPDA, automaton::Automaton, automaton::AutomatonBase> {
public:
	static automaton::DPDA convert( const automaton::RealTimeHeightDeterministicDPDA & pda);
	static automaton::DPDA convert( const automaton::DPDA & pda);
	static automaton::NPDA convert( const automaton::RealTimeHeightDeterministicNPDA & pda);
	static automaton::NPDA convert( const automaton::NPDA & pda);

	/**
	 * Computes epsilon closure of a state in epsilon nonfree automaton
	 */
	static automaton::Automaton convert( const automaton::Automaton & automaton );
};

}

#endif /* RHPDA_TO_PDA_H_ */
