/*
 * ToRegExp.cpp
 *
 *  Created on: 4. 3. 2014
 *	  Author: Tomas Pecka
 */

#include "ToRegExp.h"
#include "ToRegExpAlgebraic.h"

namespace grammar {

namespace convert {

regexp::RegExp ToRegExp::convert(const grammar::Grammar& grammar) {
	return dispatch(grammar.getData());
}

regexp::RegExp ToRegExp::convert(const grammar::RightRG& grammar) {
	return regexp::RegExp(ToRegExpAlgebraic::convert(grammar));
}

auto ToRegExpRightRG = ToRegExp::RegistratorWrapper<regexp::RegExp, grammar::RightRG>(ToRegExp::convert);

regexp::RegExp ToRegExp::convert(const grammar::LeftRG& grammar) {
	return regexp::RegExp(ToRegExpAlgebraic::convert(grammar));
}

auto ToRegExpLeftRG = ToRegExp::RegistratorWrapper<regexp::RegExp, grammar::LeftRG>(ToRegExp::convert);

} /* namespace convert */

} /* namespace grammar */
