/*
 * GenerateUpToLength.h
 *
 *  Created on: 22. 3. 2014
 *	  Author: Jan Travnicek
 */

#ifndef GRAMMAR_GENERATE_UP_TO_LENGTH_H_
#define GRAMMAR_GENERATE_UP_TO_LENGTH_H_

#include <core/multipleDispatch.hpp>

#include <grammar/Grammar.h>
#include <string/LinearString.h>
#include <set>

namespace grammar {

namespace generate {

/**
 * Implements algorithms from Melichar, chapter 3.3
 */
class GenerateUpToLength : public std::SingleDispatchLastStaticParam<GenerateUpToLength, std::set<string::LinearString>, grammar::GrammarBase, unsigned> {
public:
	static std::set<string::LinearString> generate( const grammar::Grammar & grammar, unsigned length );

	template<class T>
	static std::set<string::LinearString> generate( const T & grammar, unsigned length );
};

} /* namespace generate */

} /* namespace grammar */

#endif /* GRAMMAR_GENERATE_UP_TO_LENGTH_H_ */
