/*
 * DeterministicLL1ParseTable.cpp
 *
 *  Created on: 9. 6. 2015
 *	  Author: Tomas Pecka
 */

#include "DeterministicLL1ParseTable.h"

#include <exception/CommonException.h>

namespace grammar {

namespace parsing {

std::map < std::pair < std::variant < alphabet::Symbol, string::Epsilon >, alphabet::Symbol >, std::vector < alphabet::Symbol > > DeterministicLL1ParseTable::parseTable ( const std::map < std::pair < std::variant < alphabet::Symbol, string::Epsilon >, alphabet::Symbol >, std::set < std::vector < alphabet::Symbol > > > & parseTable ) {

	for ( const std::pair < const std::pair < std::variant < alphabet::Symbol, string::Epsilon >, alphabet::Symbol >, std::set < std::vector < alphabet::Symbol > > > & elem : parseTable )
		if ( elem.second.size ( ) > 1 )
			throw exception::CommonException ( "Cant handle conflict in epsilon" );

	std::map < std::pair < std::variant < alphabet::Symbol, string::Epsilon >, alphabet::Symbol >, std::vector < alphabet::Symbol > > res;

	for ( const std::pair < const std::pair < std::variant < alphabet::Symbol, string::Epsilon >, alphabet::Symbol >, std::set < std::vector < alphabet::Symbol > > > & elem : parseTable )
		if ( elem.second.size ( ) == 1 )
			res.insert ( std::make_pair ( elem.first, * elem.second.begin ( ) ) );

	return res;
}

} /* namespace parsing */

} /* namespace grammar */
