/*
 * IsLanguageGeneratingEpsilon.h
 *
 *  Created on: 22. 3. 2014
 *	  Author: Jan Travnicek
 */

#ifndef IS_LANGUAGE_GENERATING_EPSILON_H_
#define IS_LANGUAGE_GENERATING_EPSILON_H_

#include <core/multipleDispatch.hpp>

#include <grammar/Grammar.h>

namespace grammar {

namespace properties {

/**
 * Implements algorithms from Melichar, chapter 3.3
 */
class IsLanguageGeneratingEpsilon : public std::SingleDispatch<IsLanguageGeneratingEpsilon, bool, grammar::GrammarBase> {
public:
	static bool isLanguageGeneratingEpsilon( const grammar::Grammar & grammar );

	/*
	 * Melichar 3.6 - decides whether L( grammar ) = \0
	 *
	 * Severals steps implemented in method CFGTransformations::getProductiveNonTerminals();
	 * @see getProductiveNonTerminals
	 */
	template<class T>
	static bool isLanguageGeneratingEpsilon( const T & grammar );
};

} /* namespace properties */

} /* namespace grammar */

#endif /* IS_LANGUAGE_GENERATING_EPSILON_H_ */
