/*
 * FordFulkerson.h
 *
 *   Created on: Mar 28, 2016
 *       Author: Jan Broz
 */

#ifndef FORD_FULKERSON
#define FORD_FULKERSON

#include <unordered_map>

#include <core/multipleDispatch.hpp>
#include <graph/GraphClasses.h>

namespace graph {

namespace maximumflow {

typedef std::unordered_map< Node, std::unordered_map< Node, int > > Capacity;
typedef std::unordered_map< Node, std::unordered_map< Node, int > > Flow;

class FordFulkerson : public std::SingleDispatch2LastStaticParams< FordFulkerson, Flow, graph::GraphBase, Node, Node > {

 public:

	static Flow fordfulkerson( const Graph & graph, Node source, Node sink );

	static Flow fordfulkerson( const DirectedGraph & graph, Node source, Node sink );

	static Flow fordfulkerson( const UndirectedGraph & graph, Node source, Node sink );

};

} // namespace maximumflow

} // namespace graph

#endif // FORD_FULKERSON
