/*
 * TopogicalSort.h
 *
 *   Created on: Jun 19, 2014
 *       Author: David Rosca
 */

#ifndef GRAPH_TOPOLOGICAL_SORT_H_
#define GRAPH_TOPOLOGICAL_SORT_H_

#include <core/multipleDispatch.hpp>
#include <list>

#include <graph/GraphClasses.h>

namespace graph {

namespace sort {

class TopologicalSort : public std::SingleDispatch<TopologicalSort, std::list<Node>, graph::GraphBase> {
public:
	typedef std::list<Node> Result;

	static Result topologicalsort(const Graph &graph);

	static Result topologicalsort(const DirectedGraph &graph);
};

} // namespace sort

} // namespace graph

#endif // GRAPH_TOPOLOGICAL_SORT_H_
