/*
 * ToAutomaton.cpp
 *
 *  Created on: 11. 1. 2014
 *	  Author: Jan Travnicek
 */

#include "ToAutomaton.h"
#include "ToAutomatonGlushkov.h"

namespace regexp {

namespace convert {

automaton::Automaton ToAutomaton::convert(const regexp::RegExp& regexp) {
	return dispatch(regexp.getData());
}

automaton::Automaton ToAutomaton::convert(const regexp::FormalRegExp& regexp) {
	return automaton::Automaton(ToAutomatonGlushkov::convert(regexp));
}

auto ToAutomatonFormalRegExp = ToAutomaton::RegistratorWrapper<automaton::Automaton, regexp::FormalRegExp>(ToAutomaton::convert);

automaton::Automaton ToAutomaton::convert(const regexp::UnboundedRegExp& regexp) {
	return automaton::Automaton(ToAutomatonGlushkov::convert(regexp));
}

auto ToAutomatonUnboundedRegExp = ToAutomaton::RegistratorWrapper<automaton::Automaton, regexp::UnboundedRegExp>( ToAutomaton::convert);

} /* namespace convert */

} /* namespace regexp */
