/*
 * RegExpOptimize.cpp
 *
 *  Created on: 20. 1. 2014
 *	  Author: Tomas Pecka
 */

#include "RegExpOptimize.h"

#include "../properties/RegExpEpsilon.h"
#include <exception/CommonException.h>

#include <cassert>
#include <iostream>
#include <iostream>

namespace regexp {

namespace simplify {

regexp::RegExp RegExpOptimize::optimize(const regexp::RegExp& regexp) {
	return dispatch(regexp.getData());
}

FormalRegExp RegExpOptimize::optimize( FormalRegExp const & regexp ) {
	FormalRegExpElement* optimized = optimizeInner( regexp.getRegExp( ) );

	return FormalRegExp ( std::manage_move ( optimized ) );
}

auto RegExpOptimizeFormalRegEpx = RegExpOptimize::RegistratorWrapper<FormalRegExp, FormalRegExp>(RegExpOptimize::optimize);

UnboundedRegExp RegExpOptimize::optimize( UnboundedRegExp const & regexp ) {
	UnboundedRegExpElement* optimized = optimizeInner( regexp.getRegExp( ) );

	return UnboundedRegExp ( std::manage_move ( optimized ) );
}

auto RegExpOptimizeUnboundedRegEpx = RegExpOptimize::RegistratorWrapper<UnboundedRegExp, UnboundedRegExp>(RegExpOptimize::optimize);

} /* namespace regexp */

} /* namespace simplify */

#include "RegExpOptimizeUnboundedPart.cxx"
#include "RegExpOptimizeFormalPart.cxx"
