/*
 * ExactFactorMatch.h
 *
 *  Created on: 9. 2. 2014
 *      Author: Jan Travnicek
 */

#ifndef _EXACT_MATCH_H__
#define _EXACT_MATCH_H__

#include <string/String.h>
#include <set>
#include <core/multipleDispatch.hpp>
#include <string/StringFeatures.h>

namespace stringology {

namespace exact {

class ExactFactorMatch : public std::PromotingDoubleDispatch<ExactFactorMatch, std::set<unsigned>, string::StringBase> {
public:
	/**
	 * Performs conversion.
	 * @return left regular grammar equivalent to source automaton.
	 */
	static std::set<unsigned> match(const string::String& subject, const string::String& pattern);

	static std::set<unsigned> match(const string::LinearString& subject, const string::LinearString& pattern);
};

} /* namespace exact */

} /* namespace stringology */

#endif /* _EXACT_MATCH_H__ */
