#ifndef LR0_PARSER_TEST_H_
#define LR0_PARSER_TEST_H_

#include "grammar/ContextFree/CFG.h"
#include "alphabet/Symbol.h"

#include <cppunit/extensions/HelperMacros.h>

class LR0Parser : public CppUnit::TestFixture {
	CPPUNIT_TEST_SUITE ( LR0Parser );
	CPPUNIT_TEST ( testClosure );
	CPPUNIT_TEST ( testNextStateItems );
	CPPUNIT_TEST ( testAutomaton );
	CPPUNIT_TEST_SUITE_END ( );

	alphabet::Symbol E = alphabet::symbolFrom ( 'E' );
	alphabet::Symbol T = alphabet::symbolFrom ( 'T' );
	alphabet::Symbol F = alphabet::symbolFrom ( 'F' );

	alphabet::Symbol plus = alphabet::symbolFrom ( '+' );
	alphabet::Symbol times = alphabet::symbolFrom ( '*' );
	alphabet::Symbol leftParenthesis = alphabet::symbolFrom ( '(' );
	alphabet::Symbol rightParenthesis = alphabet::symbolFrom ( ')' );
	alphabet::Symbol identifier = alphabet::symbolFrom ( "id" );
	
	grammar::CFG getExpressionGrammar ( );

public:
	void setUp ( );
	void tearDown ( );

	void testClosure ( );
	void testNextStateItems ( );
	void testAutomaton ( );
};

#endif /* LR0_PARSER_TEST_H_ */
