#include "RegExpIntegralTest.h"

#include "regexp/transform/RegExpIntegral.h"

#include <factory/StringDataFactory.hpp>

#define CPPUNIT_IMPLY(x, y) CPPUNIT_ASSERT(!(x) || (y))

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION( RegExpIntegralTest, "regexp" );
CPPUNIT_TEST_SUITE_REGISTRATION( RegExpIntegralTest );

void RegExpIntegralTest::setUp() {
}

void RegExpIntegralTest::tearDown() {
}

void RegExpIntegralTest::testRegExpIntegral() {
    // https://edux.fit.cvut.cz/oppa/BI-AAG/cviceni/aag-cv04.pdf

    // Exc. 16
    this->ExecSingleTest("0 1 0 + 1 0 1", "1", "1 0 1 0+1 1 0 1");
}

void RegExpIntegralTest::ExecSingleTest(std::string regexp_str, std::string string_str, std::string result) {
    regexp::RegExp regexp = alib::StringDataFactory::fromString<regexp::RegExp>(regexp_str);

    string::LinearString string = static_cast<const string::LinearString&>(alib::StringDataFactory::fromString<string::String>("\"" + string_str + "\"").getData());

    std::cout << alib::StringDataFactory::toString<regexp::RegExp>(regexp::RegExpIntegral::integral(regexp, string)) << " == " << result << std::endl;

    CPPUNIT_ASSERT(alib::StringDataFactory::toString<regexp::RegExp>(regexp::RegExpIntegral::integral(regexp, string)) == result);
}
