/*
 * Automaton.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Martin Zak
 */

#ifndef AUTOMATON_H_
#define AUTOMATON_H_

#include <base/WrapperBase.hpp>
#include "AutomatonBase.h"

#include "AutomatonFeatures.h"
#include <set>

namespace automaton {

/**
 * Wrapper around automata.
 */
class Automaton : public alib::WrapperBase < AutomatonBase > {
	using alib::WrapperBase < AutomatonBase >::WrapperBase;

public:
	static const std::string & getXmlTagRefName() {
		static std::string xmlTagName = "AutomatonRef";

		return xmlTagName;
	}
};

State createUniqueState ( State base, const std::set < State > & other );

} /* namespace automaton */

#endif /* AUTOMATON_H_ */
