/*
 * Label.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#ifndef LABEL_H_
#define LABEL_H_

#include <base/WrapperBase.hpp>
#include "LabelBase.h"

namespace label {

/**
 * Wrapper around automata.
 */
class Label : public alib::WrapperBase < LabelBase > {
	using alib::WrapperBase < LabelBase >::WrapperBase;

public:
	Label next ( ) const;
	void inc ( );

	static const std::string & getXmlTagRefName() {
		static std::string xmlTagName = "LabelRef";

		return xmlTagName;
	}
};

label::Label labelFrom ( int number );
label::Label labelFrom ( int number1, int number2 );
label::Label labelFrom ( char character );
label::Label labelFrom ( std::string string );
label::Label labelFrom ( const char * string );

} /* namespace label */

#endif /* LABEL_H_ */
