/*
 * FormalRegExpEpsilon.cpp
 *
 *  Created on: Jan 30, 2014
 *      Author: Jan Travnicek
 */

#include "FormalRegExpEpsilon.h"
#include "../unbounded/UnboundedRegExpEpsilon.h"
#include <sstream>

namespace regexp {

FormalRegExpEpsilon::FormalRegExpEpsilon ( ) {
	// so that default constructor is available
}

FormalRegExpElement * FormalRegExpEpsilon::clone ( ) const {
	return new FormalRegExpEpsilon ( * this );
}

FormalRegExpElement * FormalRegExpEpsilon::plunder ( ) && {
	return new FormalRegExpEpsilon ( std::move ( * this ) );
}

std::smart_ptr < UnboundedRegExpElement > FormalRegExpEpsilon::asUnbounded ( ) const {
	return std::smart_ptr < UnboundedRegExpElement > ( new UnboundedRegExpEpsilon ( ) );
}

int FormalRegExpEpsilon::compare ( const FormalRegExpEpsilon & ) const {
	return 0;
}

void FormalRegExpEpsilon::operator >>( std::ostream & out ) const {
	out << "(FormalRegExpEpsilon)";
}

bool FormalRegExpEpsilon::testSymbol ( const alphabet::Symbol & ) const {
	return false;
}

void FormalRegExpEpsilon::computeMinimalAlphabet ( std::set < alphabet::Symbol > & ) const {
}

bool FormalRegExpEpsilon::checkAlphabet ( const std::set < alphabet::Symbol > & ) const {
	return true;
}

FormalRegExpEpsilon::operator std::string ( ) const {
	std::stringstream ss;
	ss << * this;
	return ss.str ( );
}

} /* namespace regexp */
