/*
 * UnboundedRegExpEmpty.cpp
 *
 *  Created on: Jan 30, 2014
 *      Author: Jan Travnicek
 */

#include "UnboundedRegExpEmpty.h"
#include "../formal/FormalRegExpEmpty.h"
#include <sstream>

namespace regexp {

UnboundedRegExpEmpty::UnboundedRegExpEmpty ( ) {
	// so that default constructor is available
}

UnboundedRegExpElement * UnboundedRegExpEmpty::clone ( ) const {
	return new UnboundedRegExpEmpty ( * this );
}

UnboundedRegExpElement * UnboundedRegExpEmpty::plunder ( ) && {
	return new UnboundedRegExpEmpty ( std::move ( * this ) );
}

std::smart_ptr < FormalRegExpElement > UnboundedRegExpEmpty::asFormal ( ) const {
	return std::smart_ptr < FormalRegExpElement > ( new FormalRegExpEmpty ( ) );
}

int UnboundedRegExpEmpty::compare ( const UnboundedRegExpEmpty & ) const {
	return 0;
}

void UnboundedRegExpEmpty::operator >>( std::ostream & out ) const {
	out << "(UnboundedRegExpEmpty)";
}

bool UnboundedRegExpEmpty::testSymbol ( const alphabet::Symbol & ) const {
	return false;
}

bool UnboundedRegExpEmpty::checkAlphabet ( const std::set < alphabet::Symbol > & ) const {
	return true;
}

void UnboundedRegExpEmpty::computeMinimalAlphabet ( std::set < alphabet::Symbol > & ) const {
}

UnboundedRegExpEmpty::operator std::string ( ) const {
	std::stringstream ss;
	ss << * this;
	return ss.str ( );
}

} /* namespace regexp */
