/*
 * RTEBase.h
 *
 *  Created on: Feb 1, 2016
 *      Author: Tomas Pecka
 */

#ifndef RTE_BASE_H_
#define RTE_BASE_H_

#include <object/ObjectBase.h>
#include <set>
#include "../alphabet/RankedSymbol.h"

namespace rte {

class RTEBase : public alib::ObjectBase {
public:
	virtual RTEBase * clone ( ) const = 0;
	virtual RTEBase * plunder ( ) &&  = 0;

	virtual const std::set < alphabet::RankedSymbol > & getAlphabet ( ) const = 0;
	virtual const std::set < alphabet::RankedSymbol > & getConstantAlphabet ( ) const = 0;
};

} /* namespace rte */

#endif /* RTE_BASE_H_ */
