/*
 * RTEFromXMLParser.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Martin Zak
 */

#ifndef RTE_FROM_XML_PARSER_H_
#define RTE_FROM_XML_PARSER_H_

#include <set>
#include <deque>
#include "../RTEFeatures.h"
#include "../../alphabet/SymbolFeatures.h"
#include <sax/Token.h>

namespace rte {

/**
 * Parser used to get RTE from XML parsed into list of tokens.
 */
class RTEFromXMLParser {
public:
	static std::pair < std::set < alphabet::RankedSymbol >, std::set < alphabet::RankedSymbol > > parseAlphabet ( std::deque < sax::Token >::iterator & input );

	/*
	 * static UnboundedRTEElement* parseUnboundedRTEElement(std::deque<sax::Token>::iterator& input);
	 *
	 * static UnboundedRTEEpsilon* parseUnboundedRTEEpsilon(std::deque<sax::Token>::iterator& input);
	 * static UnboundedRTEEmpty* parseUnboundedRTEEmpty(std::deque<sax::Token>::iterator& input);
	 * static UnboundedRTEIteration* parseUnboundedRTEIteration(std::deque<sax::Token>::iterator& input);
	 * static UnboundedRTEAlternation* parseUnboundedRTEAlternation(std::deque<sax::Token>::iterator& input);
	 * static UnboundedRTESubstitution* parseUnboundedRTESubstitution(std::deque<sax::Token>::iterator& input);
	 */

	static std::rvalue_ref < FormalRTEElement > parseFormalRTEElement ( std::deque < sax::Token >::iterator & input );

	static std::rvalue_ref < FormalRTEEmpty > parseFormalRTEEmpty ( std::deque < sax::Token >::iterator & input );
	static std::rvalue_ref < FormalRTEIteration > parseFormalRTEIteration ( std::deque < sax::Token >::iterator & input );
	static std::rvalue_ref < FormalRTEAlternation > parseFormalRTEAlternation ( std::deque < sax::Token >::iterator & input );
	static std::rvalue_ref < FormalRTESubstitution > parseFormalRTESubstitution ( std::deque < sax::Token >::iterator & input );
	static std::rvalue_ref < FormalRTESymbol > parseFormalRTESymbol ( std::deque < sax::Token >::iterator & input );
};

} /* namespace rte */

#endif /* RTE_FROM_XML_PARSER_H_ */
