#ifndef RTE_TO_XML_COMPOSER_H_
#define RTE_TO_XML_COMPOSER_H_

#include <deque>
#include "../RTEFeatures.h"

// #include "../unbounded/UnboundedRTEElement.h"
#include "../formal/FormalRTEElement.h"
#include <sax/Token.h>

namespace rte {

/**
 * This class contains methods to print XML representation of regular tree expression to the output stream.
 */
class RTEToXMLComposer : /*public UnboundedRTEElement::const_visitor_type,*/ public FormalRTEElementVisitor {
public:
	RTEToXMLComposer ( ) { }

	static RTEToXMLComposer RTE_TO_XML_COMPOSER;

	static void composeAlphabet ( std::deque < sax::Token > & out, const std::set < alphabet::RankedSymbol > & alphabetF, const std::set < alphabet::RankedSymbol > & alphabetK );

private:
	/*
	 * void Visit(void*, const UnboundedRTEAlternation& alternation) const;
	 * void Visit(void*, const UnboundedRTEConcatenation& concatenation) const;
	 * void Visit(void*, const UnboundedRTEIteration& iteration) const;
	 * void Visit(void*, const UnboundedRTESymbol& symbol) const;
	 * void Visit(void*, const UnboundedRTEEpsilon& epsilon) const;
	 * void Visit(void*, const UnboundedRTEEmpty& empty) const;
	 */

	void Visit ( void *, const FormalRTEAlternation & alternation ) const;
	void Visit ( void *, const FormalRTEIteration & iteration ) const;
	void Visit ( void *, const FormalRTESubstitution & concatenation ) const;
	void Visit ( void *, const FormalRTESymbol & symbol ) const;
	void Visit ( void *, const FormalRTEEmpty & empty ) const;
};

} /* namespace rte */

#endif /* RTE_TO_XML_COMPOSER_H_ */
