/*
 * StringAuxiliary.cpp
 *
 *  Created on: May 7, 2016
 *      Author: Jan Travnicek
 */

#include "StringAuxiliary.h"
#include "../../alphabet/Symbol.h"
#include "../../alphabet/RankedSymbol.h"

namespace string {

std::vector < alphabet::Symbol > StringAuxiliary::toInternal ( const std::string & rawString ) {
	std::vector < alphabet::Symbol > data;
	for ( const char& symbol : rawString ) {
		data.push_back( alphabet::symbolFrom ( symbol ) );
	}
	return data;
}

std::vector < alphabet::Symbol > StringAuxiliary::wrapSymbols ( const std::vector < alphabet::RankedSymbol > & ranked ) {
	return std::transform < alphabet::Symbol > ( ranked, [&] ( const alphabet::RankedSymbol & symbol) {
			return alphabet::Symbol ( symbol );
	} );
}

std::set < alphabet::Symbol > StringAuxiliary::wrapSymbols ( const std::set < alphabet::RankedSymbol > & ranked ) {
	return std::transform < alphabet::Symbol > ( ranked, [&] ( const alphabet::RankedSymbol & symbol) {
			return alphabet::Symbol ( symbol );
	} );
}

} /* namespace string */
