/*
 * RankedTreeBase.h
 *
 *  Created on: Nov 16, 2014
 *      Author: Stepan Plachy
 */

#ifndef RANKED_TREE_BASE_H_
#define RANKED_TREE_BASE_H_

#include "TreeBase.h"
#include <set>
#include "../alphabet/RankedSymbol.h"

namespace tree {

/**
 * Represents symbol in an alphabet.
 */
class RankedTreeBase : public tree::TreeBase {
public:
	virtual RankedTreeBase * clone ( ) const = 0;
	virtual RankedTreeBase * plunder ( ) && = 0;

	virtual const std::set < alphabet::RankedSymbol > & getAlphabet ( ) const = 0;
	virtual void extendAlphabet ( const std::set < alphabet::RankedSymbol > & symbols ) = 0;
};

} /* namespace tree */

#endif /* RANKED_TREE_BASE_H_ */
