/*
 * TreeFromRawParser.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef TREE_FROM_RAW_PARSER
#define TREE_FROM_RAW_PARSER

#include <set>
#include <deque>
#include <sax/Token.h>
#include <tree/TreeFeatures.h>

namespace tree {

class TreeFromRawParser {
public:
	TreeFromRawParser() {}

	Tree parseTree(std::deque<sax::Token>::iterator& input) const;
	Tree parseTree(std::deque<sax::Token>::iterator& input, const std::set<FEATURES>& features) const;

private:
	UnrankedNode parseContent(std::deque<sax::Token>::iterator& input) const;
};

} /* namespace tree */

#endif /* TREE_FROM_RAW_PARSER */
