/*
 * GraphFromStringLexer.h
 *
 *   Created on: Jun 19, 2014
 *       Author: David Rosca
 */

#ifndef GRAPH_FROM_STRING_LEXER_H_
#define GRAPH_FROM_STRING_LEXER_H_

#include <string>
#include <istream>

namespace graph {

class GraphFromStringLexer
{
public:
	enum class TokenType {
		LPAR,
		RPAR,
		COLON,
		COMMA,
		EQUAL,
		INTEGER,
		TEOF,
		ERROR
	};

	struct Token {
		TokenType type;
		std::string value;
		std::string raw;
	};

	Token next(std::istream &input) const;
	Token peek(std::istream &input) const;
	void putback(std::istream &input, Token token) const;

	std::string getString(std::istream &input) const;
};

} // namespace graph

#endif // GRAPH_FROM_STRING_LEXER_H_
