/*
 * LabelFromStringParser.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef LABEL_FROM_STRING_PARSER_H_
#define LABEL_FROM_STRING_PARSER_H_

#include "LabelFromStringLexer.h"
#include "label/LabelFeatures.h"
#include <set>

namespace alib {

template<typename T>
struct stringApi;

} /* namespace alib */

namespace label {

class LabelFromStringParser {
public:
	LabelFromStringParser() {}

private:
	LabelFromStringLexer m_Lexer;

	Label parseLabel(std::istream&, const std::set<FEATURES>&) const;
	Label parseLabel(std::istream&) const;

	template<typename T> friend struct alib::stringApi;
};

} /* namespace label */

#endif /* LABEL_FROM_STRING_PARSER_H_ */
