/*
 * TreeFromStringLexer.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef TREE_FROM_STRING_LEXER_H_
#define TREE_FROM_STRING_LEXER_H_

#include <string>
#include <istream>

namespace tree {

class TreeFromStringLexer {
public:
	enum class TokenType {
		BAR, RANK, SUBTREE_WILDCARD, NONLINEAR_VARIABLE, TEOF, ERROR
	};

	struct Token {
		TokenType	type;
		std::string value;
		std::string raw;
	};

	Token next ( std::istream & input ) const;
	void putback ( std::istream &, Token token ) const;
};

} /* namespace tree */

#endif /* TREE_FROM_STRING_LEXER_H_ */
