#include <list>
#include "LabelTest.h"

#include "sax/SaxParseInterface.h"
#include "sax/SaxComposeInterface.h"

#include "label/Label.h"
#include "label/PrimitiveLabel.h"

#include "primitive/Integer.h"
#include "primitive/Character.h"
#include "primitive/String.h"

#include "factory/XmlDataFactory.hpp"
#include "factory/StringDataFactory.hpp"
#include <algorithm>

#define CPPUNIT_EXCLUSIVE_OR(x, y) CPPUNIT_ASSERT((!(x) && (y)) || ((x) && !(y)))

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION( LabelTest, "label" );
CPPUNIT_TEST_SUITE_REGISTRATION( LabelTest );

void LabelTest::setUp() {
}

void LabelTest::tearDown() {
}

void LabelTest::testEqual() {
	{
		std::string input = "1";
		label::Label label = alib::StringDataFactory::fromString<label::Label>(input);

		std::string output = alib::StringDataFactory::toString(label);

		CPPUNIT_ASSERT( input == output );

		label::Label label2 = alib::StringDataFactory::fromString<label::Label>(output);

		CPPUNIT_ASSERT( label == label2 );
	}
	{
		std::string input = "'aaaa'";
		label::Label label = alib::StringDataFactory::fromString<label::Label>(input);

		std::string output = alib::StringDataFactory::toString(label);

		CPPUNIT_ASSERT( input == output );

		label::Label label2 = alib::StringDataFactory::fromString<label::Label>(output);

		CPPUNIT_ASSERT( label == label2 );
	}
	{
		std::string input = "[1, 2, 3]";
		label::Label label = alib::StringDataFactory::fromString<label::Label>(input);

		std::string output = alib::StringDataFactory::toString(label);

		CPPUNIT_ASSERT( input == output );

		label::Label label2 = alib::StringDataFactory::fromString<label::Label>(output);

		CPPUNIT_ASSERT( label == label2 );
	}
	{
		std::string input = "<1, 2>";
		label::Label label = alib::StringDataFactory::fromString<label::Label>(input);

		std::string output = alib::StringDataFactory::toString(label);

		CPPUNIT_ASSERT( input == output );

		label::Label label2 = alib::StringDataFactory::fromString<label::Label>(output);

		CPPUNIT_ASSERT( label == label2 );
	}
}

