/*
 * GrammarStat.cpp
 *
 *  Created on: 20. 9. 2014
 *	  Author: Jan Travnicek
 */

#include "GrammarStat.h"
#include "common/Printer.hpp"

#include <grammar/Regular/RightRG.h>
#include <grammar/Regular/RightLG.h>

void GrammarStat::stat ( const grammar::Grammar & grammar, const GrammarSettings & settings ) {
	dispatch ( grammar.getData ( ), settings );
}

void GrammarStat::stat ( const grammar::RightRG & grammar, const GrammarSettings & settings ) {
	Printer::PrintSet ( settings.nonterminals, grammar.getNonterminalAlphabet ( ) );
	Printer::PrintSet ( settings.terminals, grammar.getTerminalAlphabet ( ) );
	Printer::PrintValue ( settings.initialSymbols, grammar.getInitialSymbol ( ) );
	Printer::PrintMap ( settings.rules, grammar.getRules ( ) );
}

auto GrammarStatRightRG = GrammarStat::RegistratorWrapper < void, grammar::RightRG > ( GrammarStat::stat );

void GrammarStat::stat ( const grammar::RightLG & grammar, const GrammarSettings & settings ) {
	Printer::PrintSet ( settings.nonterminals, grammar.getNonterminalAlphabet ( ) );
	Printer::PrintSet ( settings.terminals, grammar.getTerminalAlphabet ( ) );
	Printer::PrintValue ( settings.initialSymbols, grammar.getInitialSymbol ( ) );
	Printer::PrintMap ( settings.rules, grammar.getRules ( ) );
}

auto GrammarStatRightLG = GrammarStat::RegistratorWrapper < void, grammar::RightLG > ( GrammarStat::stat );
